/* 페이징 관련 변수 */
let appContentTotalCount   = 0;
let appContentTotalPages   = 0;

/*aggird*/
let appContentAgGridData = [];

let appContentSelectId = "";

/****************************************************************************
 * 검색 날짜 설정
 //(A:오늘, B:3일, C:7일, D:최근30일, E:최근90일, F:이번달, G:올해, H:지난주, I:지난달)
 ****************************************************************************/
function fn_appContentSetDate(param){
    if("A"==param){
        // 오늘
        let toDate = new Date();
        let year  = toDate.getFullYear();
        let month = toDate.getMonth() + 1;
        let day   = toDate.getDate();

        if(month < 10) month = "0" + month;
        if(day < 10) day = "0" + day;

        appContentSearchStartDate = year+'-'+month+'-'+day;
        appContentSearchEndDate   = year+'-'+month+'-'+day;
    }
    else if("B"==param){
        // 3일
        // 검색 종료일자
        let toDate = new Date();
        let year  = toDate.getFullYear();
        let month = toDate.getMonth() + 1;
        let day   = toDate.getDate();

        if(month < 10) month = "0" + month;
        if(day < 10) day = "0" + day;

        appContentSearchEndDate   = year+'-'+month+'-'+day;

        // 검색 시작일자
        toDate.setDate(toDate.getDate() - 3);
        year  = toDate.getFullYear();
        month = toDate.getMonth() + 1;
        day   = toDate.getDate();

        if(month < 10) month = "0" + month;
        if(day < 10) day = "0" + day;

        appContentSearchStartDate = year+'-'+month+'-'+day;
    }
    else if("C"==param){
        // 이번주
        // 검색 종료일자
        let toDate = new Date();
        let year  = toDate.getFullYear();
        let month = toDate.getMonth() + 1;
        let day   = toDate.getDate();

        if(month < 10) month = "0" + month;
        if(day < 10) day = "0" + day;

        appContentSearchEndDate   = year+'-'+month+'-'+day;

        // 검색 시작일자
        toDate.setDate(toDate.getDate() - 7);
        year  = toDate.getFullYear();
        month = toDate.getMonth() + 1;
        day   = toDate.getDate();

        if(month < 10) month = "0" + month;
        if(day < 10) day = "0" + day;

        appContentSearchStartDate = year+'-'+month+'-'+day;
    }
    else if("D"==param){
        // 최근30일
        let toDate = new Date();
        let year  = toDate.getFullYear();
        let month = toDate.getMonth() + 1;
        let day   = toDate.getDate();

        if(month < 10) month = "0" + month;
        if(day < 10) day = "0" + day;

        //최근30일
        toDate.setDate(toDate.getDate() - 30);
        startYear  = toDate.getFullYear();
        startMonth = toDate.getMonth() + 1;
        startDay   = toDate.getDate();

        if(startMonth < 10) startMonth = "0" + startMonth;
        if(startDay < 10) startDay = "0" + startDay;

        appContentSearchStartDate = startYear+'-'+startMonth+'-'+startDay;
        appContentSearchEndDate   = year+'-'+month+'-'+day;

    }
    else if("E"==param){
        // 최근90일
        // 검색 종료일자
        let toDate = new Date();
        let year  = toDate.getFullYear();
        let month = toDate.getMonth() + 1;
        let day   = toDate.getDate();

        if(month < 10) month = "0" + month;
        if(day < 10) day = "0" + day;

        appContentSearchEndDate   = year+'-'+month+'-'+day;

        // 검색 시작일자
        toDate.setDate(toDate.getDate() - 90);
        year  = toDate.getFullYear();
        month = toDate.getMonth() + 1;
        day   = toDate.getDate();

        if(month < 10) month = "0" + month;
        if(day < 10) day = "0" + day;

        appContentSearchStartDate = year+'-'+month+'-'+day;
    }
    else if("F"==param){
        //F:이번달
        // 검색 종료일자
        let toDate = new Date();
        let year  = toDate.getFullYear();
        let month = toDate.getMonth() + 1;
        let day   = toDate.getDate();

        if(month < 10) month = "0" + month;
        if(day < 10) day = "0" + day;

        appContentSearchEndDate   = year+'-'+month+'-'+day;

        // 검색 시작일자
        appContentSearchStartDate = year+'-'+month+'-01';
    }
    else if("G"==param){
        // G:올해
        // 검색 종료일자
        let toDate = new Date();
        let year  = toDate.getFullYear();
        let month = toDate.getMonth() + 1;
        let day   = toDate.getDate();

        if(month < 10) month = "0" + month;
        if(day < 10) day = "0" + day;

        appContentSearchEndDate   = year+'-'+month+'-'+day;

        // 검색 시작일자
        appContentSearchStartDate = year+'-01-01';
    }
    else if("H"==param){
        // H:지난주, I:지난달
        // 검색 종료일자
        let toDate = new Date();
        let year  = toDate.getFullYear();
        let month = toDate.getMonth() + 1;
        let day   = toDate.getDate();

        if(month < 10) month = "0" + month;
        if(day < 10) day = "0" + day;

        appContentSearchEndDate   = year+'-'+month+'-'+day;

        // 검색 시작일자
        appContentSearchStartDate = year+'-01-01';
    }
    else if("I"==param){
        // I:지난달
        // 검색 종료일자
        let toDate = new Date();
        let year  = toDate.getFullYear();
        let month = toDate.getMonth() + 1;
        let day   = toDate.getDate();

        if(month < 10) month = "0" + month;
        if(day < 10) day = "0" + day;

        appContentSearchEndDate   = year+'-'+month+'-'+day;

        // 검색 시작일자
        appContentSearchStartDate = year+'-01-01';
    }

    $("#appContentSearchStartDate").val(appContentSearchStartDate).trigger("change");
    $("#appContentSearchEndDate").val(appContentSearchEndDate).trigger("change");
}


/****************************************************************************
 * 콘텐츠 정보 리스트 조회
 ****************************************************************************/
function fn_selectListAppContentJson(){
    let formData = new FormData();
    formData.append("menuClass", menuClass);
    formData.append("appContentSearchKeywordParam", appContentSearchKeywordParam);
    formData.append("appContentCategoryName", appContentCategoryName);
    formData.append("appContentSort", appContentSort);
    formData.append("appContentDir", appContentDir);
    formData.append("appContentStart", appContentStart);
    formData.append("appContentLimit", appContentLimit);
    formData.append("appContentSearchStartDate", appContentSearchStartDate);
    formData.append("appContentSearchEndDate", appContentSearchEndDate);
    formData.append("appContentSearchDateType", appContentSearchDateType);

    $.ajax({
        url: encodeURI('/webappcontents/selectListAppContents.do'),
        data: formData,
        dataType: "json",
        processData: false,
        contentType: false,
        type: 'POST',
        async: true,
        success: function(data){
            if('0'==data.msgCode){
                // 페이징 처리
                appContentTotalCount  = data.totalCount;
                //$("#txt_noticeTotalCount").text(noticeTotalCount);

                appContentTotalPages = Math.ceil(appContentTotalCount/appContentLimit);

                // 리스트 조회
                appContentAgGridData = data.rows;
                appContentGridOptions.api.setRowData(appContentAgGridData);

                if(0<data.rows.length){
                    //페이징 처리
                    window.pagObj = $('#appContentPagination').twbsPagination({
                        startPage    : ((appContentStart/appContentLimit)+1),
                        totalPages   : (appContentTotalPages==0)?1:appContentTotalPages,
                        visiblePages : 10,
                        initiateStartPageClick: false,
                        prev         : '<img src="/image/web/page_navigation_arrow.svg" alt="prev"/>',
                        next         : '<img src="/image/web/page_navigation_arrow.svg" alt="next"/>',
                        first        : '',
                        last         : '',
                        onPageClick: function (event, page) {
                            fn_appContentPagination(page);
                        }
                    }).on('page', function (event, page) {
                        //console.info(page + ' (from event listening)');
                    });
                }
                else{

                }
            }
            else{
                modalEvent.danger("조회 오류", data.msgDesc);
            }
        },
        error : function(xhr, status, error) {
            modalEvent.danger("조회 오류", "조회 중 오류가 발생하였습니다. 잠시후 다시시도하십시오.");
        },
        beforeSend:function(){
            // 로딩열기
            appContentGridOptions.api.showLoadingOverlay();
        },
        complete:function(){

        }
    });
}

/****************************************************************************
 * 검색하기
 ****************************************************************************/
function fn_appContentSearch(param){
    if("A"!=param && "Y"!=selectUseYn){
        modalEvent.warning("", "조회 권한이 없습니다.");
        return false;
    }

    fn_appContentPaginReset();

    appContentSearchKeywordParam = $("#appContentSearchKeyword").val();

    appContentCategoryName = $("#appContentCategoryName").val();

    appContentSearchDateType  = $("#appContentSearchDateType").val();
    appContentSearchStartDate = $("#appContentSearchStartDate").val();
    appContentSearchEndDate   = $("#appContentSearchEndDate").val();

    fn_selectListAppContentJson();
}


/****************************************************************************
 * 초기화하기
 ****************************************************************************/
function fn_appContentReset(){
    fn_appContentSetDate('D');
    $("#appContentSearchDateType option:eq(0)").prop("selected", true);

    $("#appContentSearchKeyword").val("");

    fn_appContentSearch();
}

/****************************************************************************
 * 페이징 처리
 ****************************************************************************/
function fn_appContentPagination(param){
    appContentStart = (parseInt(param)-1)*appContentLimit;

    fn_selectListAppContentJson();
}

/****************************************************************************
 * 페이징 리셋
 ****************************************************************************/
function fn_appContentPaginReset(){
    appContentSearchKeywordParam = '';

    appContentStart        = 0;
    appContentLimit        = 100;
    appContentTotalCount   = 0;
    appContentTotalPages   = 0;

    //페이징 초기화
    if($("#appContentPagination").data("twbs-pagination")){
        $("#appContentPagination").twbsPagination("destroy");
    }
}

/****************************************************************************
 * 콘텐츠 삭제
 ****************************************************************************/
function fn_deleteAppContent(){
    if("Y"!=deleteUseYn){
        modalEvent.warning("", "삭제 권한이 없습니다.");
        return false;
    }

    if(!appContentSelectId){
        modalEvent.warning("", "삭제할 대상을 선택하세요.");
        return false;
    }

    modalEvent.info("삭제", "선택한 콘텐츠 정보를 삭제하시겠습니까?", function(){
        let formData = new FormData();
        formData.append("menuClass", menuClass);
        formData.append("selectId", appContentSelectId);

        $.ajax({
            url: encodeURI('/webappcontents/deleteAppContents.do'),
            data: formData,
            dataType: "json",
            processData: false,
            contentType: false,
            type: 'POST',
            async: true,
            success: function(data){
                if('0'==data.msgCode){
                    modalEvent.success("삭제 성공", data.msgDesc, function(){
                        fn_appContentOk();
                    });
                }
                else{
                    modalEvent.danger("삭제 오류", data.msgDesc);
                }
            },
            error : function(xhr, status, error) {
                modalEvent.danger("삭제 오류", "삭제 중 오류가 발생하였습니다. 잠시후 다시시도하십시오.");
            },
            beforeSend:function(){

            },
            complete:function(){

            }
        });
    });
}

/****************************************************************************
 * 검색 엔터 이벤트
 ****************************************************************************/
function fn_appContentEnter(e){
    if(e.which){
        // 파이어폭스
        if(13 == e.which) {
            //로그인 액션 스크립트
            fn_appContentSearch();
        }
    }
    else{
        // 윈도우, 사파리, 크롬
        if(13 == event.keyCode) {
            //로그인 액션 스크립트
            fn_appContentSearch();
        }
    }
}

/****************************************************************************
 * 정렬 이벤트
 ****************************************************************************/
function fn_alignContent(param, param2){
    let align = "";

    if("A"==param){
        align = "오늘";

        fn_appContentSetDate('A');
    }
    else if("B"==param){
        align = "최근30일";

        fn_appContentSetDate('D');
    }
    else if("C"==param){
        align = "최근90일";

        fn_appContentSetDate('E');
    }
    else if("D"==param){
        align = "이번주";

        fn_appContentSetDate('C');
    }
    else if("E"==param){
        align = "이번달";

        fn_appContentSetDate('F');
    }
    else if("F"==param){
        align = "올해";

        fn_appContentSetDate('G');
    }
    else if("G"==param){
        align = "지난주";

        fn_appContentSetDate('H');
    }
    else if("H"==param){
        align = "지난달";

        fn_appContentSetDate('I');
    }
    else{
        align = "";
    }
    $("#appContentSearchDateType").val(param);
    $("#appContentSearchDateType").siblings("button").text(align);
}

/****************************************************************************
 * 완료
 ****************************************************************************/
function fn_appContentOk(){
    fn_appContentReset();
}

/****************************************************************************
 * 등록 화면으로 이동.
 ****************************************************************************/
function fn_insertAppContentIntro(){
    if("Y"==insertUseYn){
        let pagingParam = "?menuClass="+menuClass;
        fn_leftFormAction("/webappcontents/insertContentsIntro.do"+pagingParam);
    }else{
        modalEvent.warning("", "등록 권한이 없습니다.");
        return false;
    }

}

/****************************************************************************
 * 수정 화면으로 이동.
 ****************************************************************************/
function fn_updateAppContentIntro(muAppContentId){
    if("Y"==updateUseYn){
        let pagingParam = "?menuClass="+menuClass;
        pagingParam    += "&muAppContentId="+muAppContentId;
        fn_leftFormAction("/webappcontents/updateContentsIntro.do"+pagingParam);
    }else{
        modalEvent.warning("", "수정 권한이 없습니다.");
        return false;
    }
}
function thumbnailCellRenderer(params) {
    if(!params.value)
        return
    else
        return `<img src="${params.value.replace("C:", "")}" width="40" height="40" alt="Thumbnail">`;
}

let appContentColumnDefs = [
    {field: "checkbox", headerName:"", minWidth:55, maxWidth:55, headerCheckboxSelection: true, checkboxSelection: true},
    /* {field: "rowNum", headerName:"번호", minWidth:80,maxWidth:80, sortable: false}, */
    {field: "rowNum", headerName:"번호", minWidth:60,sortable: false, cellStyle:{textAlign: 'center'}},
    {field: "appContentCategoryName", headerName:"카테고리", minWidth:200},
    {field: "filePath2", headerName:"섬네일", minWidth:100, cellRenderer: thumbnailCellRenderer},
    {field: "title", headerName:"제목", minWidth:250, cellStyle:{cursor: 'pointer', color:'#3985EA'}},
    {field: "content", headerName:"내용",minWidth:500},
    {field: "writeDate", headerName:"등록일",minWidth:250, maxWidth:250},
    {field: "writeName", headerName:"작성자",minWidth:150, maxWidth:200},
];

// let the grid know which columns and what data to use
let appContentGridOptions = {
    suppressRowTransform: true,
    columnDefs: appContentColumnDefs,
    defaultColDef: {		// 리스트 기본 설정
        flex: 1,
        sortable: true,		//정렬 여부
        resizable: true,	//리사이즈
        editable: true,	// 그리드에서 데이터 수정
        cellStyle:{textAlign:'left',fontSize:'14px',padding:'0'},
        //suppressSizeToFit:true,		//자동 맞춤
        //enableRowGroup: true,		// 그룹 묶음
        enablePivot: true,
        enableValue : true
    },
    //suppressMultiSort:true,  //단일솔트 true가 단일, false가 다중 shift + sort 시
    headerHeight : 41, // header 높이
    rowHeight : 41, // row 높이
    rowData : appContentAgGridData,
    suppressRowClickSelection : true, // 로우 클릭시 체크박스 선택 true no, false yes
    localeText : {
        noRowsToShow : '조회 결과가 없습니다.'
    }, //데이터 없을 시 나오는 문구
    rowSelection : 'multiple', // row 다중 선택
    debug : false,
    onCellClicked: function(event){ //셀 클릭 이벤트
        /* alert(event.column.colId); */
        if('title'==event.column.colId){
            fn_updateAppContentIntro(event.data.muAppContentId);
        }
    },
    onSelectionChanged: function(event){ //체크박스 선택
        let selectRows = [];
        selectRows = event.api.getSelectedRows();

        appContentSelectId = '';
        for(let i=0; i<selectRows.length; i++){
            appContentSelectId += selectRows[i].muAppContentId + ",";
        }
        appContentSelectId = appContentSelectId.substring(0, appContentSelectId.lastIndexOf(','));
    },
    onSortChanged: function(event){
        //정렬
        appContentSort = ''; //기존 정렬 초기화
        let columnArr = event.columnApi.getColumnState();
        if(0<columnArr.length){
            //sort index 순으로 재정렬
            columnArr.sort(function(a,b){
                return a.sortIndex - b.sortIndex;
            });

            let nullCnt = 0;
            for(let i=0; i<columnArr.length; i++){
                let gridSortModel = columnArr[i].colId;
                let gridSort = columnArr[i].sort;

                if(gridSort != null){
                    appContentStart = 0;
                    appContentSort += gridSortModel+' '+ gridSort + ',';
                }
                else{
                    nullCnt++;
                    if(nullCnt == columnArr.length){
                        appContentSort = '';
                        appContentDir = '';
                        appContentStart = 0;
                    }
                }
            }
        }
        appContentSort = appContentSort.substring(0,appContentSort.lastIndexOf( ",")); //맨끝 콤마 지우기

        fn_appContentSearch();
    }
};

// lookup the container we want the Grid to use
let appContentGridDiv = document.querySelector('#appContentGrid');

// create the grid passing in the div to use together with the columns & data we want to use
new agGrid.Grid(appContentGridDiv, appContentGridOptions);





/****************************************************************************
 * 페이지 init
 ****************************************************************************/
function fn_pageInit(){
    // 날짜 datepicker
    fn_searchDatePicker("#divAppContentSearchStartDate", "#divAppContentSearchEndDate");

    if(!appContentSearchStartDate&&!appContentSearchEndDate){
        // 검색 오늘날짜 셋팅
        fn_appContentSetDate('D');
    }else{
        $("#appContentSearchStartDate").val(appContentSearchStartDate).trigger("change");
        $("#appContentSearchEndDate").val(appContentSearchEndDate).trigger("change");
    }

    // 초기 페이징 처리
    $("#appContentSearchKeyword").val(appContentSearchKeywordParam);

    fn_appContentSearch("A");
}

/****************************************************************************
 * 페이지 event
 ****************************************************************************/
function fn_pageEvent(){
    // 검색 input
    $(document).on('keypress', '#appContentSearchKeyword', function(e) {
        fn_appContentEnter(e);
    });

    // 검색 조회 버튼
    $("#btnSearchAppContent").click(function () {
        fn_appContentSearch();
    });

    // 콘텐츠 등록 팝업 버튼
    $("#btnInsertAppContent").click(function () {
        fn_insertAppContentIntro();
    });

    // 콘텐츠 삭제 버튼
    $("#btnDeleteAppContent").click(function () {
        fn_deleteAppContent();
    });

    // 기간 선택 콤보 이벤트
    const target = $("#appContentSearchDateType").siblings("ul.select_option_list");
    target.find("li.option_list_item").click(function () {
        let selectIdArr = $(this).prop("id").split('_');
        let selectId    = selectIdArr[1];
        let selectName  = $(this).text();

        $(this).parent().siblings("button").text(selectName);
        $(this).parent().siblings("input").val(selectId);

        fn_alignContent(selectId);
    });

    // 카테고리 선택 콤보 이벤트
    const categoryTarget = $("#appContentCategoryName").siblings("ul.select_option_list");
    categoryTarget.find("li.option_list_item").click(function () {
        let selectIdArr = $(this).prop("id").split('_');
        let selectId    = selectIdArr[1];
        let selectName  = $(this).text();

        if(selectId.match("ALL")){
            selectId = '';
        }
        $(this).parent().siblings("button").text(selectName);
        $(this).parent().siblings("input").val(selectId);
    });
}

$(function(){
    // 페이지 init
    fn_pageInit();

    // 페이지 event
    fn_pageEvent();
});